package com.example.schedulerapp;


import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.*;
import javafx.stage.Stage;

import java.io.IOException;
import java.time.LocalDate;
import java.util.ArrayList;

public class Controller {
    @FXML
    BorderPane myBorderPane;
    @FXML
    VBox leftSideButtons;
    @FXML
    BorderPane rootBorderPane;
    @FXML
    TextArea employees;
    @FXML
    private TextField addFirstName;
    @FXML
    private TextField addLastName;
    @FXML
    private TextField removeID;
    @FXML
    Button addShiftSubmitButton;
    @FXML
    DatePicker addShiftDatePicker;
    @FXML
    TextField addShiftStartTime;
    @FXML
    TextField addShiftEndTime;
    @FXML
    ComboBox addShiftEmployeeBox;
    @FXML
    HBox addShiftEmployeeHBox;




    Stage popupStage;
    Scene popupScene;
    RafisWeirdClass rafisWeirdClass = new RafisWeirdClass();
    Model model = new Model("10.237.93.139",8989);

    public void scheduleButtonClicked() throws IOException {
        System.out.println("schedule button clicked");
        dailyScheduleButtonClicked();
        leftSideButtons.setVisible(true);
    }
    public void paystubButtonClicked() throws IOException {
        System.out.println("paystub button clicked");
        FXMLLoader fxmlLoader = new FXMLLoader(ScheduleApp.class.getResource("paystubView.fxml"));
        myBorderPane.setCenter(fxmlLoader.load());
        leftSideButtons.setVisible(false);
    }
    public void availabilityButtonClicked() {
        System.out.println("availability button clicked");
    }
    public void timeoffButtonClicked () {
        System.out.println("timeoff button clicked");
    }
    public void dailyScheduleButtonClicked() throws IOException {
        System.out.println("daily schedule button clicked");
        FXMLLoader fxmlLoader = new FXMLLoader(ScheduleApp.class.getResource("dailySchedule.fxml"));
        myBorderPane.setCenter(fxmlLoader.load());
    }

    public void weeklyScheduleButtonClicked () throws Exception {
        System.out.println("weekly schedule button clicked");
        FXMLLoader fxmlLoader = new FXMLLoader(ScheduleApp.class.getResource("weeklySchedule.fxml"));
        myBorderPane.setCenter(fxmlLoader.load());
    }
    public void pickupsButtonClicked () {
        System.out.println("pickups button clicked");
    }
    public void prevButtonClicked () {
        System.out.println("prev button clicked");
    }
    public void jumpButtonClicked () {
        System.out.println("jump button clicked");
    }
    public void nextButtonClicked () {
        System.out.println("next button clicked");
    }

    public void addShiftClicked() throws IOException {
        FXMLLoader popupLoader = new FXMLLoader(this.getClass().getResource("addShiftPopup.fxml"));
        popupScene = new Scene(popupLoader.load(),500,500);
        popupStage = new Stage();
        popupStage.setScene(popupScene);
        popupStage.show();
    }

    public void populateEmployeeBox(MouseEvent event) {

        ArrayList<String> aList = model.returnFormattedEmployeeNames();
        ObservableList<String> list = FXCollections.observableArrayList();
        aList.forEach(employee-> list.add(employee));

        ComboBox test = (ComboBox) event.getSource();
        test.setItems(list);
    }

    public void addShiftSubmitClicked(MouseEvent event){
        System.out.println("submit clicked");
        String employee = (String) addShiftEmployeeBox.getValue();
        System.out.println(addShiftEmployeeBox.getSelectionModel().getSelectedIndex());
        String startTime = addShiftStartTime.getText();
        String endTime = addShiftEndTime.getText();
        LocalDate date = addShiftDatePicker.getValue();

        System.out.println(employee + startTime + endTime + date);
    }


    // Login Page
    public void managerLoginClicked (MouseEvent mouseEvent) throws IOException {
        FXMLLoader gridLoader = new FXMLLoader(this.getClass().getResource("dailySchedManager.fxml"));
        FXMLLoader headerLoader = new FXMLLoader(this.getClass().getResource("headerManager.fxml"));
        FXMLLoader sideLoader = new FXMLLoader(this.getClass().getResource("schedSidePanel.fxml"));
        FXMLLoader bottomLoader = new FXMLLoader(this.getClass().getResource("schedBottomPanelManager.fxml"));

        clearRootBorderPane();

        rootBorderPane.setTop(headerLoader.load());
        rootBorderPane.setLeft(sideLoader.load());
        rootBorderPane.setBottom(bottomLoader.load());
        rootBorderPane.setCenter(gridLoader.load());
    }
    public void employeeLoginClicked (MouseEvent mouseEvent) throws IOException {
        FXMLLoader employeeLoader = new FXMLLoader(this.getClass().getResource("employeeMainView.fxml"));
        clearRootBorderPane();
        rootBorderPane.setCenter(employeeLoader.load());
    }
    // Header
    public void mangerLogoutClicked (MouseEvent mouseEvent) throws IOException {
        FXMLLoader loginLoader = new FXMLLoader(this.getClass().getResource("login.fxml"));
        clearRootBorderPane();
        rootBorderPane.setCenter(loginLoader.load());
    }
    // Manager Page
    // Staff Section
    // Switch to Staff Page
    public void staffManagerClicked (MouseEvent mouseEvent) throws IOException {
        FXMLLoader gridLoader = new FXMLLoader(this.getClass().getResource("addEmployee.fxml"));
        FXMLLoader headerLoader = new FXMLLoader(this.getClass().getResource("headerManager.fxml"));
        FXMLLoader sideLoader = new FXMLLoader(this.getClass().getResource("staffManagerSidePanel.fxml"));

        clearRootBorderPane();

        rootBorderPane.setTop(headerLoader.load());
        rootBorderPane.setLeft(sideLoader.load());
        rootBorderPane.setCenter(gridLoader.load());
    }

    private void clearRootBorderPane() {
        rootBorderPane.setCenter(null);
        rootBorderPane.setLeft(null);
        rootBorderPane.setRight(null);
        rootBorderPane.setTop(null);
        rootBorderPane.setBottom(null);
    }

    // Side Panel
    // Switch to Edit Employee
    public void editStaffSidePanelClicked (MouseEvent mouseEvent) throws IOException {
        FXMLLoader gridLoader = new FXMLLoader(this.getClass().getResource("editEmployee.fxml"));
        FXMLLoader headerLoader = new FXMLLoader(this.getClass().getResource("headerManager.fxml"));
        FXMLLoader sideLoader = new FXMLLoader(this.getClass().getResource("staffManagerSidePanel.fxml"));

        clearRootBorderPane();

        rootBorderPane.setTop(headerLoader.load());
        rootBorderPane.setLeft(sideLoader.load());
        rootBorderPane.setCenter(gridLoader.load());
    }
    // Switch to Remove Employee
    public void removeStaffSidePanelClicked (MouseEvent mouseEvent) throws IOException {
        FXMLLoader gridLoader = new FXMLLoader(this.getClass().getResource("removeEmployee.fxml"));
        FXMLLoader headerLoader = new FXMLLoader(this.getClass().getResource("headerManager.fxml"));
        FXMLLoader sideLoader = new FXMLLoader(this.getClass().getResource("staffManagerSidePanel.fxml"));

        clearRootBorderPane();

        rootBorderPane.setTop(headerLoader.load());
        rootBorderPane.setLeft(sideLoader.load());
        rootBorderPane.setCenter(gridLoader.load());
    }
    // Switch to View Employees

    public void viewStaffSidePanelClicked (MouseEvent mouseEvent) throws IOException {
        FXMLLoader gridLoader = new FXMLLoader(this.getClass().getResource("viewEmployees.fxml"));
        FXMLLoader headerLoader = new FXMLLoader(this.getClass().getResource("headerManager.fxml"));
        FXMLLoader sideLoader = new FXMLLoader(this.getClass().getResource("staffManagerSidePanel.fxml"));

        clearRootBorderPane();

        rootBorderPane.setTop(headerLoader.load());
        rootBorderPane.setLeft(sideLoader.load());
        rootBorderPane.setCenter(gridLoader.load());
    }
    // Add, Edit, Remove Functions
    // Add Employee
    public void addEmployeeClicked (MouseEvent mouseEvent){
        String firstName = addFirstName.getText();
        String lastName = addLastName.getText();
        rafisWeirdClass.staff.addEmployee(firstName, lastName);
        System.out.println("Employee " + firstName + " " + lastName + " added to Staff. Welcome "
                + firstName + "!");
    }
    // Edit employee
    public void editEmployeeClicked (MouseEvent mouseEvent){
        //edit employee
    }
    // Remove Employee
    public void removeEmployeeClicked (MouseEvent mouseEvent){
        int id = Integer.parseInt(removeID.getText());
        rafisWeirdClass.staff.removeEmployee(id);
    }
    // View Employees
}